package com.fjhx.customer.entity.xiaoman.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class CustomerInfoVo {

    @JsonProperty("company_id")
    private long companyId;

    @JsonProperty("serial_id")
    private String serialId;

    @JsonProperty("user_id")
    private List<String> userId;

    @Data
    public static class Owner {
        @JsonProperty("user_id")
        private String userId;

        @JsonProperty("avatar")
        private String avatar;

        @JsonProperty("name")
        private String name;

        @JsonProperty("nickname")
        private String nickname;
    }

    @JsonProperty("owner")
    private List<Owner> owner;

    @JsonProperty("create_user")
    private long createUser;

    @Data
    public static class LastOwnerInfo {
        @JsonProperty("nickname")
        private String nickname;

        @JsonProperty("user_id")
        private long userId;

        @JsonProperty("avatar")
        private String avatar;
    }

    @JsonProperty("last_owner_info")
    private LastOwnerInfo lastOwnerInfo;

    @JsonProperty("pool_id")
    private int poolId;

    @JsonProperty("pool_name")
    private String poolName;

    @JsonProperty("private_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "Asia/Shanghai")
    private Date privateTime;

    @JsonProperty("public_time")
    private String publicTime;

    @JsonProperty("release_count")
    private int releaseCount;

    @JsonProperty("edit_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "Asia/Shanghai")
    private Date editTime;

    @JsonProperty("main_lead_id")
    private long mainLeadId;

    @JsonProperty("lead_name")
    private String leadName;

    @JsonProperty("origin")
    private String origin;

    @JsonProperty("origin_name")
    private String originName;

    @JsonProperty("tag")
    private List<Tag> tag;

    @JsonProperty("client_tag_list")
    private List<String> clientTagList;

    public static class SourceDetail {
        @JsonProperty("alibaba_store_info")
        private List<AlibabaStoreInfo> alibabaStoreInfo;

        @JsonProperty("site_info")
        private List<String> siteInfo;

    }

    @JsonProperty("source_detail")
    private SourceDetail sourceDetail;

    @JsonProperty("name")
    private String name;

    @JsonProperty("short_name")
    private String shortName;

    @JsonProperty("origin_list")
    private List<String> originList;

    @JsonProperty("biz_type")
    private String bizType;

    // 嵌套的内部类
    @Data
    public static class AlibabaStoreInfo {
        @JsonProperty("store_id")
        private String storeId;

        @JsonProperty("store_name")
        private String storeName;

        @JsonProperty("enable_flag")
        private String enableFlag;

        @JsonProperty("oauth_flag")
        private String oauthFlag;

        @JsonProperty("sync_customer_flag")
        private String syncCustomerFlag;

    }


    @JsonProperty("annual_procurement")
    private int annualProcurement;

    @JsonProperty("country")
    private String country;

    @JsonProperty("intention_level")
    private int intentionLevel;

    @JsonProperty("province")
    private String province;

    @JsonProperty("timezone")
    private String timezone;

    @JsonProperty("city")
    private String city;

    @JsonProperty("scale_id")
    private Long scaleId;

    @JsonProperty("trail_status")
    private String trailStatus;

    @JsonProperty("homepage")
    private String homepage;

    @JsonProperty("fax")
    private String fax;

    @JsonProperty("tel_area_code")
    private String telAreaCode;

    @JsonProperty("tel")
    private String tel;

    @JsonProperty("address")
    private String address;

    @JsonProperty("remark")
    private String remark;

    @JsonProperty("category_ids")
    private List<Integer> categoryIds;

    @JsonProperty("create_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "Asia/Shanghai")
    private Date createTime;

    @JsonProperty("customers")
    private List<Customer> customers;

    @JsonProperty("country_name")
    private String countryName;

    @Data
    public static class Customer {
        @JsonProperty("customer_id")
        private long customerId;

        @JsonProperty("company_id")
        private long companyId;

        @JsonProperty("name")
        private String name;

        @JsonProperty("email")
        private String email;

        @JsonProperty("gender")
        private int gender;

        @JsonProperty("remark")
        private String remark;

        @JsonProperty("birth")
        private String birth;

        @JsonProperty("post_grade")
        private int postGrade;

        @JsonProperty("post")
        private String post;

        @JsonProperty("image_list")
        private List<ImageInfo> imageList;

        @JsonProperty("contact")
        private List<Contact> contact;

        @JsonProperty("main_customer_flag")
        private int mainCustomerFlag;

        @JsonProperty("tel_area_code")
        private String telAreaCode;

        @JsonProperty("tel")
        private String tel;

    }

    @Data
    public static class ImageInfo {
        @JsonProperty("file_id")
        private long fileId;

        @JsonProperty("file_name")
        private String fileName;

        @JsonProperty("file_size")
        private String fileSize;

        @JsonProperty("file_path")
        private String filePath;

        @JsonProperty("file_preview_url")
        private String filePreviewUrl;
    }


    @Data
    public static class Contact {

        @JsonProperty("type")
        private String type;

        @JsonProperty("value")
        private String value;
    }


    @Data
    public static class Tag {

        @JsonProperty("tag_color")
        private String tagColor;

        @JsonProperty("tag_id")
        private String tagId;

        @JsonProperty("tag_name")
        private String tagName;

        @JsonProperty("user_id")
        private String userId;

        @JsonProperty("system_flag")
        private String systemFlag;

        @JsonProperty("create_time")
        @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
        private Date createTime;

        @JsonProperty("user_info")
        private List<Object> userInfo;

    }



}
